﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.Misc;
using Infragistics.Win.UltraWinGrid;

namespace WG_CustomSummaryDialog
{
    public partial class Form1 : Form
    {
        private UltraGridColumn summaryCol;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataSet ds = new DataSet();
            DataTable t1 = ds.Tables.Add("table1");
            t1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Name", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("Price", typeof(double));
            t1.Columns.Add("Date", typeof(DateTime));

            ds.Tables["table1"].Rows.Add(new Object[] { null, "Beverage", 50, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Appliances", 5, 90, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "FastFood", 20, 32, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Furniture", 12, 79, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Meat", 40, 10.2, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Fruits", 25, 12, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Vegetables", 30, 13, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Cars", 13, 200, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Tools", 60, 15.3, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Estate", 5, 3000, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Motorcycles", 10, 320, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Clothes", 40, 69, new DateTime(2009, 02, 28) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Shoes", 24, 40.6, new DateTime(2008, 04, 22) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Games", 53, 50, new DateTime(2012, 05, 10) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Books", 42, 22, new DateTime(2005, 10, 05) });
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Movies", 38, 19, new DateTime(2009, 02, 28) });

            ultraGrid1.DataSource = ds;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Override.AllowRowSummaries = Infragistics.Win.UltraWinGrid.AllowRowSummaries.BasedOnDataType;
        }

        private void ultraGrid1_BeforeSummaryDialog(object sender, Infragistics.Win.UltraWinGrid.BeforeSummaryDialogEventArgs e)
        {
            e.Cancel = true;

            DialogResult dr;
            this.summaryCol = e.Column;

            using (var sDialog = new MySummaryDialog(summaryCol, new SummaryDialogSettings(e.Column.Layout)))
            {
                dr = sDialog.ShowDialog();

                if (dr == System.Windows.Forms.DialogResult.OK)
                {
                    this.UpdateSummaries(sDialog);
                }
            }
        }

        private void UpdateSummaries(MySummaryDialog sDialog)
        {
            var customSummary = summaryCol.Band.Summaries.
                GetSummary(summaryCol, SummaryType.Custom);
            var sumSummary = summaryCol.Band.Summaries.
                GetSummary(summaryCol, SummaryType.Sum);

            if(sDialog.ApplyCustomSumSummary && customSummary == null)
            {
                customSummary = summaryCol.Band.Summaries.Add("");
                customSummary.CustomSummaryCalculator = new MyCustomSummaryCalculator();
                customSummary.SourceColumn = summaryCol;
                customSummary.SummaryType = SummaryType.Custom;
                customSummary.SummaryPosition = SummaryPosition.UseSummaryPositionColumn;
                customSummary.SummaryPositionColumn = summaryCol;
            }
            if(sDialog.ApplyCustomSumSummary == false && customSummary != null)  
            {
                 summaryCol.Band.Summaries.Remove(customSummary);
            }

            if (sDialog.ApplySumSummary && sumSummary == null)
            {
                sumSummary = summaryCol.Band.Summaries.Add(SummaryType.Sum, summaryCol);
            }
            if (sDialog.ApplySumSummary == false && sumSummary != null)
            {
                summaryCol.Band.Summaries.Remove(sumSummary);
            }
        }
    }
}
