﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace WG_CustomSummaryDialog
{
    public partial class MySummaryDialog : Form
    {
        private UltraGridColumn ultraGridColumn;
        private SummaryDialogSettings summaryDialogSettings;

        private bool applySumSummary;
        private bool applyCustomSumSummary;

        public MySummaryDialog(UltraGridColumn ultraGridColumn, SummaryDialogSettings summaryDialogSettings)
        {
            InitializeComponent();

            this.ultraGridColumn = ultraGridColumn;
            this.summaryDialogSettings = summaryDialogSettings;

            this.Icon = this.summaryDialogSettings.IconDialog;
            this.Text = "Select Summaries";

            this.sumCheckEditor.Appearance.Image = this.summaryDialogSettings.ImageSumResolved;

            this.sumCheckEditor.Checked = ultraGridColumn.Band.Summaries.GetSummary(ultraGridColumn, SummaryType.Sum) != null;
            this.customSumCheckEditor.Checked = ultraGridColumn.Band.Summaries.GetSummary(ultraGridColumn, SummaryType.Custom) != null;
        }

        public bool ApplyCustomSumSummary
        {
            get { return applyCustomSumSummary; }
            private set { applyCustomSumSummary = value; }
        }

        public bool ApplySumSummary
        {
            get { return applySumSummary; }
            private set { applySumSummary = value; }
        }

        private void sumCheckEditor_CheckedChanged(object sender, EventArgs e)
        {
            this.ApplySumSummary = this.sumCheckEditor.Checked;
        }

        private void customSumCheckEditor_CheckedChanged(object sender, EventArgs e)
        {
            this.ApplyCustomSumSummary = this.customSumCheckEditor.Checked;
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            this.DialogResult = System.Windows.Forms.DialogResult.OK;
            this.Close();
        }

        protected override void OnClosed(EventArgs e)
        {
            this.summaryDialogSettings.Dispose();

            base.OnClosed(e);
        }



    }
}
